<?php // Include only
if (!defined('BOOT')) exit('No bootstrap.  Exiting.');

/*
niftyToo code by Marcello Basta-Forte (http://marcello.cellosoft.com)

Wacintaki Poteto modifications Copyright 2004-2011 Marc "Waccoon" Leveille
http://www.NineChime.com/products/
Version 1.5.6 - Last modified 2011-03-17
*/


//
// Smilies
// If you don't like these, edit your own in hacks.php so updates will not wipe out your changes.
if (USE_SMILE_HACK != 1 || !isset($smilies_group)) {
	// Escape all HTML entities!
	$smilies_group = array(
		':)' => 'smile.gif',
		':|' => 'neutral.gif',
		':(' => 'sad.gif',
		':D' => 'big_smile.gif',
		'&gt;:)'   => 'smirk.gif',
		'&gt;:D'   => 'evil_smile.gif',
		':sneaky:' => 'sneaky.gif',
		':o' => 'yikes.gif',
		';)' => 'wink.gif',
		':/' => 'hmm.gif',
		':P' => 'tongue.gif',
		':lol:'      => 'lol.gif',
		':mad:'      => 'mad.gif',
		':rolleyes:' => 'rolleyes.gif',
		':cool:'   => 'cool.gif',
		':duh:'    => 'duh.gif',
		':blush:'  => 'blush.gif',
		':cry:'    => 'cry.gif',
		':boohoo:' => 'boohoo.gif',
		':crazy:'  => 'crazy.gif',
		':what:'   => 'what.gif',
		':gamer:'  => 'gamer.gif',
		':barf:'   => 'barf.gif'
	);
}


function nifty2_convert($out) {
	global $cfg;
	global $user;
	global $OekakiU;

	if (isset($GLOBALS['smilies_group']))
		global $smilies_group;

	// Init
	$mode = 1;


	// HTML markup
	$out = htmlspecialchars($out);
	// $out = htmlentities($out, ENT_NOQUOTES);
	// $out = eregi_replace('&amp;(#[0-9]{1,5});','&\\1;',$out);
	// $out = preg_replace('/&amp;(#[0-9]{1,5});/i','&\\1;',$out);


	// Formatting
	$out = stripslashes($out);
	$out = nl2br($out);
	$out = str_replace(array("\r", "\n"), '', $out);


	// Autolink URL
	// Regex slurps leading char, so put it back with '\1'
	$out = preg_replace('!([^]:,=]|^)(http://[[:alnum:]\?\$:+_%&amp;=@#/.~-]+[[:alnum:]+_%/-])!i'
		, "\\1<a href=\"\\2\" target=\"_blank\">\\2</a>"
		, $out);


	// Using BBCode?  Save us some proccessing time
	if (strpos($out, '[') !== false) {

		// Clean up brackets
		nifty2_replace($out, 'no', "nifty2_fix_brackets('\\1')", $mode, 'es');
		$out = str_replace(array('[[', ']]'), array('&#91;', '&#93;'), $out);


		// Local URL redirect, return if found
		if (strpos($out, '[local') !== false) {
			// URL tag w/attribute
			nifty2_replace($out, 'local'
				, "'<a href=\"'.nifty2_local_url('\\1').'\">\\2</a>'"
				, $mode, 'me', '[^]"]+');
			// URL tag, no attribute
			nifty2_replace($out, 'local'
				, "'<a href=\"'.nifty2_local_url('\\1').'\">\\1</a>'"
				, $mode, 'me');

			return $out;
		}


		// URL tag w/attribute
		nifty2_replace($out, 'url'
			, "'<a href=\"'.nifty2_nice_url('\\1').'\"'.nifty2_url_target('\\1').'>\\2</a>'"
			, $mode
			, 'me'
			, '[^]"]+'
		);
		// URL tag, no attribute
		nifty2_replace($out, 'url'
			, "'<a href=\"'.nifty2_nice_url('\\1').'\"'.nifty2_url_target('\\1').'>\\1</a>'"
			, $mode
			, 'me'
		);
		nifty2_replace($out, 'email'
			, "'<a href=\"mailto:'.nifty2_fix_brackets('\\1').'\">\\2</a>'"
			, $mode
			, 'me'
			, '[^]"]+'
		);
		nifty2_replace($out, 'email'
			, "'<a href=\"mailto:'.nifty2_fix_brackets('\\1').'\">\\1</a>'"
			, $mode
			, 'me'
		);
		$out = preg_replace(
			'/\[email[:=\s](.+?)\]/mei'
			, "'<a href=\"mailto:'.nifty2_fix_brackets('\\1').'\">'\\1</a>'"
			, $out
		);


		// Tag substitutes
		$sub_in = array('[s]', '[/s]', '[strike]', '[/strike]');
		$sub_out = array('[del]', '[/del]', '[del]', '[/del]');
		$out = str_replace($sub_in, $sub_out, $out);


		// Quoted text
		$sub_in  = '<blockquote style="margin: 1em 2em 0 2em;"><em>'.t('ldquo');
		$sub_out = t('rdquo').'</em></blockquote>';
		$out = preg_replace(
			'/\[quote\](.+?)\[\/quote\]/mei'
			, "'{$sub_in}'.nifty2_fix_brackets('\\1').'{$sub_out}'"
			, $out
		);


		// Basic tags
		nifty2_replacetag($out, 'b', $mode);
		nifty2_replacetag($out, 'u', $mode);
		nifty2_replacetag($out, 'i', $mode);
		nifty2_replacetag($out, 'code', $mode);
		nifty2_replacetag($out, 'big', $mode);
		nifty2_replacetag($out, 'small', $mode);
		nifty2_replacetag($out, 'del', $mode);
		nifty2_replacetag($out, 'sub', $mode);
		nifty2_replacetag($out, 'sup', $mode);


		// Tags with attributes
		nifty2_replace($out, 'color', '<span style="color: \\1">\\2</span>', $mode, 's', '#[0-9A-Fa-f]{6}|[a-zA-Z]+');
		nifty2_replace($out, 'color', '<span style="color: \\1; background-color: \\2;">\\3</span>', $mode, 's', '#[0-9A-Fa-f]{6}|[a-zA-Z]+)\s+on\s+(#[0-9A-Fa-f]{6}|[a-zA-Z]+', 2);
	}


	// Smilies ($out must be HTML)
	if ($cfg['smilies'] != 'no') {
		// Show for guests, or if enabled in a user's profile
		if (empty($OekakiU) || $user['smilies_show']) {
			$out = ' '.$out.' '; // Padding for smilies test
			foreach ($smilies_group as $smile_in => $smile_out) {
				$smile_find = "/(\s|>)".preg_quote($smile_in, '/')."(\s|<)/";
				$smile_put = '\1<img src="smilies/'.$smile_out.'" style="border: 0;" alt="'.$smile_in.'" />\2';
				$out = preg_replace($smile_find, $smile_put, $out);
			}
			$out = substr($out, 1, -1); // Remove padding
		}
	}

	return $out;
}


function nifty2_replacetag(&$text, $tag, $mode=1) {
	nifty2_replace($text, $tag, '<'.$tag.'>\\1</'.$tag.'>', $mode);
}

/* NOT USED
function nifty2_customtag(&$text, $tag, $replace, $mode = 1) {
	$text = preg_replace('/\['.$tag.'\]/i', $replace, $text);
	nifty2_replace($text, $tag, '<'.$tag.'>\\1</'.$tag.'>', $mode);
}
*/

function nifty2_replace(&$text, $tag, $replace, $mode = 1, $flags = 's', $parameter = null, $parameters = 0) {
	if ($parameter && isset($parameters)) {
		$parameters = 1;
	}

	if ($mode == 1) {
		$text = preg_replace(
			'/\['.$tag.($parameters?'[:=\s]\s*('.$parameter.')':'').'\](.+?)[\n\r\f]?(?:$|\[\/'.$tag.'\])/i'.$flags
			, $replace
			, $text
		);
	} else {
		$text = preg_replace(
			'/(\['.$tag.($parameters?'[:=\s]\s*(?:'.nifty2_strip_parentheses($parameter).')':'').'\])(.+?)[\n\r\f]?($|\[\/'.$tag.'\])/i'.str_replace('e', '', $flags)
			, ($mode == -1 ? '\\2' : '<font color="red">\\1</font>\\2<font color="red">\\3</font>')
			, $text
		);
	}
}

function nifty2_smiley(&$text, $smile, $name) {
	$text = str_replace("[$smile]", '<img src="/images/smilies/'.$name.'.gif" style="border: 0;" />',$text);
}

/* NOT USED
function nifty2_html($text) {
	return str_replace(']', '&#93;', str_replace('[', '&#91;', $text));
}
*/

function nifty2_fix_brackets($text) {
	return stripslashes(str_replace(']', '&#93;', str_replace('[', '&#91;', $text)));
}

function nifty2_nice_url($url) {
	$url=str_replace(' ', '%20', str_replace('<', '&lt;', nifty2_fix_brackets(stripslashes($url))));

	if (!preg_match('/(^[a-z]+):/', $url)) {
		return "http://$url";
	}

	return $url;
}

function nifty2_local_url($url) {
	$url=str_replace(' ', '%20', str_replace('<', '&lt;', nifty2_fix_brackets(stripslashes($url))));

	return $url;
}

function nifty2_url_target($url) {
	$parse = parse_url(nifty2_nice_url($url));

	// if (ereg(MATCHDOMAIN, $parse['host']) && ereg('^'.PATH, $parse['path'])) {
	// 	return;
	// }
	if ($parse['scheme'] == 'mailto' || $parse['scheme'] == 'irc') {
		return;
	}
	return ' target="_blank"';
}

/* NOT USED
function nifty2_strip_br($text) {
	return stripslashes(preg_replace('/<br\s*\/>/i', '', $text));
}
*/

function nifty2_strip_parentheses($text) {
	return str_replace('(', '(?:', $text);
}